## mingw-w64-mold-2.31.0-2.src.tar.zst

=== third-party/tbb/examples/graph/binpack/CMakeLists.txt ===
# Copyright (c) 2020-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.1)

project(binpack CXX)

include(../../common/cmake/common.cmake)

set_common_project_settings(tbb)

add_executable(binpack binpack.cpp)

target_link_libraries(binpack TBB::tbb Threads::Threads)
target_compile_options(binpack PRIVATE ${TBB_CXX_STD_FLAG})

set(EXECUTABLE "$<TARGET_FILE:binpack>")
set(ARGS 4 elements_num=1000)
set(PERF_ARGS auto elements_num=1000 silent)

add_execution_target(run_binpack binpack ${EXECUTABLE} "${ARGS}")
add_execution_target(perf_run_binpack binpack ${EXECUTABLE} "${PERF_ARGS}")
